/*
    <one line to give the program's name and a brief idea of what it does.>
    Copyright (C) 2011  <asgharagha> <email>

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/


#ifndef BHV_BLOCK_H
#define BHV_BLOCK_H



#include <rcsc/player/soccer_action.h>
#include <rcsc/player/player_agent.h>
#include <rcsc/geom/vector_2d.h>
#include <vector>
#include <rcsc/common/server_param.h>

//#include "bhv_anticipate_pass.h"

#include "strategy.h"
#include <rcsc/math_util.h>
#include <rcsc/common/server_param.h>
#include <rcsc/geom/composite_region_2d.h>
#include <rcsc/action/basic_actions.h>
#include <rcsc/action/bhv_go_to_point_look_ball.h>
#include <rcsc/action/body_go_to_point.h>

#define MAXSIZE 25

#include <rcsc/player/soccer_action.h>

using namespace rcsc;

class Bhv_Block : public rcsc::SoccerBehavior
{
private:
  bool meBestBlocker(PlayerAgent *agent);
  bool isBlockMom (PlayerAgent *agent);
  Vector2D calcBlockPos(PlayerAgent * agent);
  bool twoBlockersNeeded(PlayerAgent *agent);
  static int tar_unum;
  static bool tar_bool;
  static Vector2D last_pos;
  static Vector2D last_o_pos;
  static double   last_o_dir;
  Vector2D tem_pos;
  bool penalty_mode;
  //static bool me=false;
  
  
public:
    Bhv_Block( bool is_penalty_mode = false )
    : penalty_mode( is_penalty_mode )
    { }
    virtual bool execute(rcsc::PlayerAgent* agent)
    {}
    bool Blockexecute(PlayerAgent*agent,Vector2D & vecblock);
};

#endif // BHV_BLOCK_H
