/*
    <one line to give the program's name and a brief idea of what it does.>
    Copyright (C) 2011  <copyright holder> <email>

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/


#ifndef TASKEVALUATOR_H
#define TASKEVALUATOR_H

#include "tasksequence.h"
#include <rcsc/player/player_agent.h>

class TaskEvaluator
{
  
private:
  std::vector<TaskSequence::TaskRoute> M_tasks;
  
public:
  TaskEvaluator( std::vector<TaskSequence::TaskRoute> tasks ):
    M_tasks( tasks )
   { }
   
   TaskSequence::TaskRoute execute( rcsc::PlayerAgent * agent );
   
   void pushEnd( TaskSequence::TaskRoute end_task );
  
};

#endif // TASKEVALUATOR_H
