/*
    <one line to give the program's name and a brief idea of what it does.>
    Copyright (C) 2012  Mohammadhossein Malmir <mhmalmir@gmail.com>

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef BHV_POSITIONING_H
#define POSITIONING_H

#include <rcsc/player/soccer_action.h>
#include <rcsc/player/player_agent.h>

using namespace rcsc;

class Bhv_Positioning
: public SoccerBehavior
{
public:
  
 // explicit
  Bhv_Positioning() {}
  
  bool execute( PlayerAgent * agent ) ;

  //////////////////////////////////////////////

private:
  
  enum PosType
  {
    MARK ,
    BLOCK ,
    HOME_POS ,
    WITHOUT_BALL ,
    INTERCEPT
  };
  
  PosType action( PlayerAgent * agent ,
		  Vector2D & target , 
		  double & dist_thr ,
		  double & dash_power ,
		  int & view_number );
  
  Vector2D HomePos( PlayerAgent * agent );
};

#endif